
/*		FROM RUMA  		*/
// 1. change in struct attack_air
// 2. change in struct attack_group

#include "attack.h"
//=========================================

// Global variables
vector <attack_group> attack_vector_group;
vector <attack_air> attack_vector_air;

 // RLS sight radius
double attack_bmaxfuel=2600./60.;    	// km	// B & I max fuel charge
double attack_imaxfuel=4800./60.;    	// km	// B & I max fuel charge
double attack_hmax=1800.;	// km	// min & max flight height (of Bomber)
double attack_hmin=700.; 	// km	// min & max flight height (of Bomber)
double attack_vbmax=1040.;	// km/h   // max velocity of Bomber
double attack_vbmin=200.;	// km/h	// min velocity of Bomber
double attack_vbcruise=800.;	// km/h   // cruise velocity of Bomber
double attack_vimax=2400.;	// km/h   // max velocity of Fighter
double attack_vimin=200.;	// km/h   // min velocity of Fighter
double attack_vicruise=2000.;	// km/h   // cruise velocity of Fighter

double Attack_BportX,Attack_BportY,Attack_IportX,Attack_IportY; // coords of airports
double Attack_Max_rocket,Attack_Max_bomb;
int Attack_Life_bomb=2;        //
int Attack_Life_istr=1;        //
int Attack_power_of_rocket=3;	  // FROM OLEG
Attack_Property Attack_var;
int LEN;


unsigned Attack_RND_x0=1023; //x0 - for my RND
//=========================================

/* Attack-module of the big program
	my part: init, take off, aims distribution and redistribution, meeting
*/
/* My identifiers:
RLS_Radius; // RLS sight radius
   //in attack_air I changed Bomb to type
const int tt_IA_home=3; // IA - big letters !
attack_bnum,attack_inum: start quantity of Bombers and Fighters
Attack_Property Attack_var: our module variables
	//Bnum,Inum;//current q-ty of crafts ON AIRPORTS !!!
	double NextTakeOffTime;
	double RAppolo; // radius of Appolo circle
	double XAppolo,YAppolo; // coords of Appolo circle center
Attack_BportX,Attack_BportY,Attack_IportX,Attack_IportY // coords of airports
attack_bmaxfuel,attack_imaxfuel // B & I max fuel charge
attack_brockets,attack_irockets
attack_vbcruise,attack_vicruise // cruise velocities
target objects[7] // global array of all objects
*/

// time is in hours, distance is in kilometers

//====== these won't be inputed from file

///////////////////////////////////////////////////////////////////////
//! this function substitutes by l1=l2
void copy(attack_group &l1,attack_group l2)
{
  l1.n_bomb=l2.n_bomb;
  l1.xmeet=l2.xmeet;
  l1.ymeet=l2.ymeet;
  l1.xobj=l2.xobj;
  l1.yobj=l2.yobj;
  l1.meet=l2.meet;
  l1.objnum=l2.objnum;
  l1.Tpike=l2.Tpike;
  l1.dv=l2.dv;
  l1.dh=l2.dh;
  l1.Yespike=l2.Yespike;
  for(int i=0;i<attack_max_sopr;i++) l1.n_istr[i]=l2.n_istr[i];
 };

/*
void push_back(attack_group p)
{
  attack_group *k;
  k=new attack_group[LEN+1];
  for(int j=0;j<LEN;j++) copy(k[j],attack_vector_group[j]);
  copy(k[LEN],p); //! copy(k[LEN+1],p);
  LEN++;
  if(LEN!=1) delete attack_vector_group;//! delete [] attack_vector_group;
  attack_vector_group=k;
 };

int pop_back(void)
{
  attack_group *k;
  if(LEN==0) return -1; //!
  if(LEN!=1) k=new attack_group[LEN-1]; //!
  else k=NULL;
  for(int j=0;j<LEN-1;j++) copy(k[j],attack_vector_group[j]);
  LEN--;
  delete attack_vector_group; //!
  attack_vector_group=k;
 return 1;
 };
  */

///////////////////////////////////////////////////////////////////////

int Attack_Init() // init of attackers
{
	double CAp;
	int i;
   double DX,DY;

   attack_brockets=current_attack_bomb.weapon;			// bombs & rockets quantity on board
	attack_irockets=current_attack_fighter.weapon; 		// bombs & rockets quantity on board
	rls_radius=current_rls.radius; // RLS sight radius
	attack_bmaxfuel=current_attack_bomb.radius*2;    	// km	// B & I max fuel charge
	attack_imaxfuel=current_attack_fighter.radius*2;    	// km	// B & I max fuel charge
	attack_hmax=current_attack_bomb.Hmax;	// km	// min & max flight height (of Bomber)
	attack_hmin=current_attack_bomb.Hmin; 	// km	// min & max flight height (of Bomber)
	attack_vbmax=current_attack_bomb.Vmax;	// km/h   // max velocity of Bomber
	attack_vbmin=current_attack_bomb.Vmin;	// km/h	// min velocity of Bomber
	attack_vbcruise=current_attack_bomb.Vcruise;	// km/h   // cruise velocity of Bomber
	attack_vimax=current_attack_fighter.Vmax;	// km/h   // max velocity of Fighter
	attack_vimin=current_attack_fighter.Vmin;	// km/h   // min velocity of Fighter
	attack_vicruise=current_attack_fighter.Vcruise;	// km/h   // cruise velocity of Fighter

   Attack_Max_rocket=attack_irockets;
   Attack_Max_bomb=attack_brockets;
   // init of airports coords
   Attack_BportX=objects[tt_BOMB_attack].x;
   Attack_BportY=objects[tt_BOMB_attack].y;
   Attack_IportX=objects[tt_IA_attack].x;
   Attack_IportY=objects[tt_IA_attack].y;

   // creation of global vector <attack_air> attack_vector_air
   attack_vector_air.resize(attack_inum+attack_bnum);


	for(i=0;i<attack_bnum;i++)
	{
		attack_vector_air[i].x=Attack_BportX;
		attack_vector_air[i].y=Attack_BportY;
		attack_vector_air[i].type=1;// Bomber
		attack_vector_air[i].rocket=attack_brockets;
		attack_vector_air[i].life=2;
		attack_vector_air[i].fly=0;
		attack_vector_air[i].tready=0.;
		attack_vector_air[i].fuel=attack_bmaxfuel;
	}
	for(;i<attack_inum+attack_bnum;i++)
	{
		attack_vector_air[i].x=Attack_IportX;
		attack_vector_air[i].y=Attack_IportY;
		attack_vector_air[i].type=0;// Fighter
		attack_vector_air[i].rocket=attack_irockets;
		attack_vector_air[i].life=1;
		attack_vector_air[i].fly=0;
		attack_vector_air[i].tready=0.;
		attack_vector_air[i].fuel=attack_imaxfuel;
	}

	// creation of EMPTY global vector <attack_group> attack_vector_group
	//attack_vector_group=NULL; //   attack_vector_group=new attack_group[0];
   attack_vector_group.resize(0);
	LEN=0;

	// inition of Attack_var
	//Attack_var.Bnum=attack_bnum;
	//Attack_var.Inum=attack_inum;
	Attack_var.NextTakeOffTime=0.;
	DX=Attack_BportX-Attack_IportX;
	DY=Attack_BportY-Attack_IportY;
	CAp=attack_vbcruise/attack_vicruise;
	Attack_var.RAppolo=CAp/(1-CAp*CAp)*sqrt(DX*DX+DY*DY);
	Attack_var.XAppolo=(Attack_BportX-Attack_IportX*CAp*CAp)/(1-CAp*CAp);
	Attack_var.YAppolo=(Attack_BportY-Attack_IportY*CAp*CAp)/(1-CAp*CAp);
	return 0;
}
//---------------------------------------------------------------------------
int Attack_ShowAim(int ng)
/*sets objnum for ng-th group according to
   1) remained objects importance
   2) rest fuel in Bomber
objnum=-1 if nowhere to aim => return on base -> made by Peter
Returning values: 0 - Bomber is aimed,         all remained objects are reached by fuel :Weight==Weight*Reached!=0
                  1 - Bomber is aimed, but not all remained objects are reached by fuel :Weight!=Weight*Reached!=0
                 -1 - no objects remained :Weight*Reached==0 && Weight==0
                 -2 - some objects remained, but no one is reached by fuel :Weight*Reached==0 && Weight!=0 */
{
	const double RetCoef=1.5;// coef of safety returning distance
	int Weight[5],Reached[5],sumweight=0,i;// Weight - remained weights,Reached=0,1 (yes/no)
	int WReq0=1,WeqWR=1,Weq0=1;//(0,1,*)->0 : returning value
                              //(0,0,*)->1
                              //(1,*,1)->-1
                              //(1,*,0)->-2
	double way;
	attack_air* pB; // pointer to bomber of group
	int choise;

	//!!!!!!!! bardak with objects. I need that all defender's objects take first 5 places in objects array
	pB=&attack_vector_air[attack_vector_group[ng].n_bomb];
	for(i=0;i<5;i++)
	{
		if(objects[i].life!=0) Weight[i]=objects[i].importance;
		else Weight[i]=0;
		way=sqrt((pB->x-objects[i].x)*(pB->x-objects[i].x)+
					(pB->y-objects[i].y)*(pB->y-objects[i].y) )
			+sqrt((objects[i].x-Attack_BportX)*(objects[i].x-Attack_BportX)+
					(objects[i].y-Attack_BportY)*(objects[i].y-Attack_BportY) )*RetCoef;
		if(way<=pB->fuel) Reached[i]=1;
		else Reached[i]=0;

		// printf("%d %d\n",Weight[i],Reached[i]); //!!
      if(Weight[i]*Reached[i]!=0) WReq0=0;
		if(Weight[i]!=Weight[i]*Reached[i]) WeqWR=0;
		if(Weight[i]!=0) Weq0=0;
		sumweight+=Weight[i]*Reached[i];
	}
	if(WReq0==1) // NO AIM
	{
		attack_vector_group[ng].objnum=-1;
		return Weq0-2;
	}
	else
	{
		choise=1+random(sumweight);
		i=0;
		while(choise>0)
		{
			choise-=Weight[i]*Reached[i];
			i++;
			if(i>=5) break; // for sure
		}
		attack_vector_group[ng].objnum=--i;
      attack_vector_group[ng].xobj=objects[i].x;
      attack_vector_group[ng].yobj=objects[i].y;
		return 1-WeqWR;
	}
}
//---------------------------------------------------------------------------
int Attack_TakeOff() //makes sincronous B&F take off, aim B,generates meeting point. Returns: 0 - nothing , 1 - took off, -1 -
{
	const int MaxRandom=1000;
	int i,escort=0,newgroup,aimed;
	double timeinter,height;
	attack_group tmp;

	double DAppolo,DBomber;
	double DXBC,DYBC,R; // coords of Bombers' Airport regarded to chosen center (RLS or Appolo center), R -radius of corresp circle
	double DXTB,DYTB; // coords of target regarded to Bombers' Airport (x_t-x_B ...)
	double lambda,lambda1,lambda2; // roots of 2-equation, 0<=lambda<=1
	double a,b,c; // coefs of equation on lambda a*l*l+2*b*l+c=0
	double D_4;
	int tarnum;


         if(Attack_var.NextTakeOffTime>cur_time) return 0;



	// Bomber take off
	for(i=0;i<attack_bnum;i++)
	{
		if(attack_vector_air[i].type==1 &&
			attack_vector_air[i].life!=0 &&
			attack_vector_air[i].fly==0  &&
			attack_vector_air[i].tready<=cur_time) break;
	}
	if(i==attack_bnum) return 0;

	// Add new element with number 'newgroup' in vector <attack_group> attack_vector_group
	attack_vector_group.push_back(tmp);
	//newgroup=LEN-1;
   newgroup=attack_vector_group.size()-1;
        

	height=attack_hmin+(random(MaxRandom-1)+1)*(attack_hmax-attack_hmin)/double(MaxRandom);
	attack_vector_air[i].h=height;
	attack_vector_air[i].v=attack_vbcruise;
	attack_vector_air[i].fly=1;
	attack_vector_group[newgroup].n_bomb=i;
	attack_vector_group[newgroup].meet=0;
	attack_vector_group[newgroup].Tpike=attack_tpike;
	attack_vector_group[newgroup].Yespike=0;
	// adding escort
	for(i=attack_bnum;i<attack_inum+attack_bnum;i++)
	{
		if(attack_vector_air[i].type==0 &&
			attack_vector_air[i].life!=0 &&
			attack_vector_air[i].fly==0  &&
			attack_vector_air[i].tready<=cur_time)
		{
			attack_vector_air[i].h=height;
			attack_vector_air[i].v=attack_vicruise;
			attack_vector_air[i].fly=1 ;
			attack_vector_group[newgroup].n_istr[escort++]=i;
			if(escort==attack_sopr) break;
		}
	}
	// make others n_istr[i] empty
     	for(i=escort;i<attack_max_sopr;i++)
		attack_vector_group[newgroup].n_istr[i]=-1;
     	// new group is formed now !!!



	// AIM BOMBER:
	aimed=Attack_ShowAim(newgroup); // sets objnum according to the rest fuel and importances
 	if(aimed==-1) return -1; //"All targets are destructed by attackers"; //!!!
	if(aimed==-2) return -2; //"Attackers cannot fly to any target - not enough fuel"; //!!!
	if(aimed==1 ) return -3; //"Attackers cannot fly to every target - not enough fuel"; //!!!

	//MAKING MEETING POINT using Appolo circle and setting xmeet,ymeet
	DAppolo=sqrt(Attack_var.XAppolo*Attack_var.XAppolo+Attack_var.YAppolo*Attack_var.YAppolo);
	DBomber=sqrt(Attack_BportX*Attack_BportX+Attack_BportY*Attack_BportY);
	if(DBomber>rls_radius && DAppolo<=rls_radius+Attack_var.RAppolo) // case III in my papers
	{
		DXBC=Attack_BportX;
		DYBC=Attack_BportY;
		R=rls_radius;
	}
	else // cases I & II in my papers
	{
		DXBC=Attack_BportX-Attack_var.XAppolo;
		DYBC=Attack_BportY-Attack_var.YAppolo;
		R=Attack_var.RAppolo;
	}
	tarnum=attack_vector_group[newgroup].objnum;
	DXTB=objects[tarnum].x-Attack_BportX;
	DYTB=objects[tarnum].y-Attack_BportY;
	a=DXTB*DXTB+DYTB*DYTB;
	b=DXBC*DXTB+DYBC*DYTB;
	c=DXBC*DXBC+DYBC*DYBC-R*R;
	D_4=b*b-a*c;
	if(D_4<0.) return -4; //"Bomber velocity > Fighter velocity OR target is outside RLS action area!";
	D_4=sqrt(D_4);
	lambda1=(-b+D_4)/a; lambda2=(-b-D_4)/a;
	if(0.<=lambda1 && lambda1<=1.) lambda=lambda1;
	else
		if(0.<=lambda2 && lambda2<=1.) lambda=lambda2;
		else return -4; //"Bomber velocity > Fighter velocity OR target is outside RLS action area!";
	if(DBomber>rls_radius && DAppolo<=rls_radius+Attack_var.RAppolo) // case III in my papers
	{
		lambda*=.5;
	}
	attack_vector_group[newgroup].xmeet=Attack_BportX+lambda*DXTB;
	attack_vector_group[newgroup].ymeet=Attack_BportY+lambda*DYTB;
   // xobj,yobj are filled in ShowAim

	// SETTING NextTakeOffTime
       timeinter=-log( (random(MaxRandom-1)+1)/double(MaxRandom) )*attack_averagetakeofftime;
	Attack_var.NextTakeOffTime+=timeinter;

	return 1;
}
//---------------------------------------------------------------------------
int Attack_Reaim() // reaiming bombers in flight. returns reaimed groups including returned to base
{
	int groups,i,aimed,reaimed=0;

 //	groups=LEN;
	groups=attack_vector_group.size();
	for(i=0;i<groups;i++)
	{
		if(objects[attack_vector_group[i].objnum].life==0)
		{
			aimed=Attack_ShowAim(i);
			if(aimed<0) attack_vector_group[i].objnum=-1;
			reaimed++;
		}
	}
	return reaimed;
}
//---------------------------------------------------------------------------
// This functin change    attack_vector_air[n_istr].x and attack_vector_air[n_istr].y

int Attack_Meeting()
{
 int quantity_of_groups,Istr_kolvo;
 int i=0,j=0,k=0,n_bomb=0,logik=1,n_istr=0,quantity_of_new_meetings=0;
 double epsilon=0, v=0,difX=0,difY=0,alfa=0;
 quantity_of_groups=attack_vector_group.size();
// quantity_of_groups=LEN;
 for(i=0;i<quantity_of_groups;i++){
    logik=1;
    Istr_kolvo=0;
    if(attack_vector_group[i].meet!=1){
      n_bomb=attack_vector_group[i].n_bomb;
      v=attack_vector_air[n_bomb].v;
      epsilon=v*dt;epsilon=epsilon*epsilon;
      for(j=0;j<attack_max_sopr;j++){
         n_istr=attack_vector_group[i].n_istr[j];
         if(n_istr!=-1){
           difX=attack_vector_group[i].xmeet-attack_vector_air[n_istr].x;
	   difY=attack_vector_group[i].ymeet-attack_vector_air[n_istr].y;
           difX=difX*difX; difY=difY*difY;
	   if(difX>epsilon||difY>epsilon)logik=0;
	 }
      }
      if(logik==1){
        Istr_kolvo=0;
	for(k=0;k<attack_max_sopr;k++)
          if(attack_vector_group[i].n_istr[k]!=-1)Istr_kolvo++;
	alfa=0;
	for(k=0;k<attack_max_sopr;k++){
	  if(attack_vector_group[i].n_istr[k]!=-1){
            n_istr=attack_vector_group[i].n_istr[k];
	    n_bomb=attack_vector_group[i].n_bomb;
	    epsilon=attack_rad_sopr;
            attack_vector_air[n_istr].x=
	    attack_vector_air[n_bomb].x+epsilon/2*cos(alfa);
	    attack_vector_air[n_istr].y=
            attack_vector_air[n_bomb].y+epsilon/2*sin(alfa);
            alfa=alfa+6.283/Istr_kolvo;
	  }
   }
	attack_vector_group[i].meet=1;
	quantity_of_new_meetings++;
      }
    }
 }
 return quantity_of_new_meetings;
}//---------------------------------------------------------------------------
/* This function change  objects[objnum].life
(the lifes of diferent enimy targets)*/

int Attack_Bombard()
{
 int i,j,quantity_of_groups,rocket_quantity;
 int objnum=0,n_bomb=0,rand=0,quantity_of_bombing=0;
 double difX=0,difY=0,epsilon=0;
 quantity_of_groups=attack_vector_group.size();
// quantity_of_groups=LEN;
 for(i=0;i<quantity_of_groups;i++){//look all groups quantity_of_groups=length of group array

      n_bomb=attack_vector_group[i].n_bomb;
      objnum=attack_vector_group[i].objnum;
      difX=attack_vector_air[n_bomb].x-objects[objnum].x;
      difY=attack_vector_air[n_bomb].y-objects[objnum].y;
      difX=difX*difX; difY=difY*difY;
      epsilon=attack_vector_air[n_bomb].v*dt;
      if(difX<epsilon&&difY<epsilon){
        rocket_quantity=attack_vector_air[n_bomb].rocket;
        for(j=0;j<rocket_quantity;j++){  //use all Rockets
	   rand=random(Attack_power_of_rocket);
           objects[objnum].life=objects[objnum].life-rand;
	}
	attack_vector_air[n_bomb].rocket=0;
	if(objects[objnum].life<0)
	  objects[objnum].life=0;
        quantity_of_bombing++;
      }

 }
 return quantity_of_bombing;
}
//---------------------------------------------------------------------------




int Attack() // called after each time step
{
   int res;

   res=Attack_TakeOff();
   if(res<0) return res;
   Attack_Reaim();
   //attack_vector_group[0].objnum=1;	////////////////////
   Attack_overview();// return to base corresponded planes
   Attack_flying();//flight
   Attack_Meeting();
   Attack_Bombard();
   return 0;
}

// int Attack_Finish() {}

//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////

// prototips:



/*struct Attack_Property {
          //double Hmin,Hmax,VImin,VImax,VBmin,VBmax; defined above & names are changed
	  // double Tpike; make it const
          int Life_bomb,Life_istr;
	  int Max_rocket,Max_bomb; //by vova they are called attack_brockets=,attack_irockets
	  // cut //int N_air_air,N_air_bomb;//tt_BOMB_attack tt_IA_attack
        	} Attack_var;//={1000,10000,10,100,20,800,5,200,2,1,10,10,10000,60,100,20,0.01};

*/

// function of deleting group's elements from q1 to q2

void Attack_del_vect_elem_group(int q1,int q2=-1)
{
  int i;
//  int KOL=LEN;
  int KOL=attack_vector_group.size();
  if (q2==-1) q2=q1;
  if ((q1>q2)||(q2>=KOL)) {printf("BAD delete");return;}

  vector <attack_group> mas;
//  attack_group *mas;
//  mas=new attack_group[LEN+1]; //!
 // int c=0;

  for(i=KOL-1;i>q2;i--) {
	//copy(mas[c++],attack_vector_group[i]);
	mas.push_back(attack_vector_group[i]);
	//pop_back();
	attack_vector_group.pop_back();

	};
  for(i=0;i<=q2-q1;i++) //pop_back();
  			attack_vector_group.pop_back();
  //KOL=c;
  KOL=mas.size();
  for(i=KOL-1;i>=0;i--) //push_back(mas[i]);
  						attack_vector_group.push_back(mas[i]);
//  delete mas; //!
  mas.erase(mas.begin(),mas.end());
 };

// function of absolut valume of x

double Attack_ABS(double x)
{
  if (x<0) x=-x;
  return x;
 }

// function - RND

double Attack_rnd(void)
{
  Attack_RND_x0=5*Attack_RND_x0%(1<<12);
  return (double)Attack_RND_x0/(1<<12);
 };

/*
void fix_(int &s,int c)
{
  for(int i=0;i<MAX_KOL_TARGET;i++)
	if (objects[i].Target_type==c) {s=i;break;}
 }
  fix_(tt_RLS,);
  fix_(tt_IA_attack,5);
  fix_(tt_BOMB_attack,6);
*/

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

/* 'overview' :

   1. obzor camoletov po gruppam i obnarujenie uni4tojenix istrebiteley ->
      -> ctavim b masiv soprovojdeniya '-1'
   2. proverka na vozvrat gruppi: a)bombordirov4ik ubit
			    b)bombordirov4ik ne imeet bomb
				  c)prinuditel'nui vozvrat (objnum=-1)
   3. ydalenie elementa gruppi
*/

void Attack_overview()
{
  attack_group l;
  attack_air p;
  int KOL=attack_vector_group.size();//LEN;//
  int i,j;

  //int *del;
  //del=new int[LEN+1];
  vector <int> del;
  for(i=0;i<KOL;i++) del.push_back(0);//del[i]=0; //del.push_back(0);
  for(i=0;i<KOL;i++) {
	l=attack_vector_group[i];
	  for(j=0;j<attack_max_sopr;j++) {
		if (l.n_istr[j]==-1) continue;
		    p=attack_vector_air[l.n_istr[j]];
		    if (!p.life) attack_vector_group[i].n_istr[j]=-1;
		    };
	  p=attack_vector_air[l.n_bomb];
	  if (p.life==0) {Attack_fallout(0,attack_vector_group[i]);del[i]=1;continue;};
	  if (p.rocket==0) {Attack_fallout(1,attack_vector_group[i]);del[i]=1;continue;};
	  if (l.objnum==-1) {Attack_fallout(1,attack_vector_group[i]);del[i]=1;continue;};
	  };
  int fl=0,n;
  for(i=KOL-1;i>=0;i--) {
	if ((!del[i])&&(fl==0)) continue;
	if ((del[i])&&(fl==0)) {n=i;fl=1;continue;};
	if ((!del[i])&&(fl==1)) {fl=0;Attack_del_vect_elem_group(i+1,n);};
  };
//  if (KOL) if (del[0]) Attack_del_vect_elem_group(0,n);
  if (del.size()) if (del[0]) Attack_del_vect_elem_group(0,n);
//  delete del;
  del.erase(del.begin(),del.end());
 };

/* 'Attack_fallout' (podfunctiya 'Attack_overview')

   1. Vozvra4aem podderjky ili bombordirov4ik

*/

void Attack_fallout(int flag,attack_group &wi)
{
  int j;
  switch (flag) {
        case 1: Attack_ready(attack_vector_air[wi.n_bomb]);
	case 0: for(j=0;j<attack_max_sopr;j++) {
			if (wi.n_istr[j]==-1) continue;
			      Attack_ready(attack_vector_air[wi.n_istr[j]]);
			      };break;
          };
 };

/* 'Attack_ready' (podfunctiya 'Attack_fallout')

   1. Pereyctanavlivaem vce zna4eniya i privodim camolet v rejim ojidaniya gotovnocti

*/

void Attack_ready(attack_air &wj)
{
  double x2,y2,T_vozvrat;

  if (!wj.type) {x2=objects[tt_IA_attack].x;y2=objects[tt_IA_attack].y;}
	else  {x2=objects[tt_BOMB_attack].x;y2=objects[tt_BOMB_attack].y;};

  double vvvvv;
  if (wj.type) vvvvv=attack_vbcruise;
	else vvvvv=attack_vicruise;

  T_vozvrat=sqrt((x2-wj.x)*(x2-wj.x)+(y2-wj.y)*(y2-wj.y))/vvvvv;
  wj.fuel-=T_vozvrat*vvvvv;

  int K_polomki;
  if (wj.type) {K_polomki=Attack_Life_bomb-wj.life;wj.life=Attack_Life_bomb;}
	else  {K_polomki=Attack_Life_istr-wj.life;wj.life=Attack_Life_istr;};

  int K_perezar;
  if (wj.type) {K_perezar=Attack_Max_bomb-wj.rocket;wj.rocket=Attack_Max_bomb;}
	else  {K_perezar=Attack_Max_rocket-wj.rocket;wj.rocket=Attack_Max_rocket;}

  double K_toplivo;
  if (wj.type) {K_toplivo=attack_bmaxfuel-wj.fuel;wj.fuel=attack_bmaxfuel;}
	else {K_toplivo=attack_imaxfuel-wj.fuel;wj.fuel=attack_imaxfuel;}

  wj.tready=cur_time+t_zaderjka+t_polomki*K_polomki+
	   t_perezar*K_perezar+t_toplivo*K_toplivo+T_vozvrat;

  wj.x=x2;
  wj.y=y2;
  wj.h=0;
  wj.v=0;
  wj.fly=0;
 }

////////////////////////////////////////////////////////////////

/*  'Attack_flying' :

   1. polet vcex camoletov gruppi c vozmojnim manevrom

*/

void Attack_flying()
{
   int KOL=attack_vector_group.size();//LEN;    //attack_vector_group.size();
   attack_group l;
   attack_air p;
   double x1,x2,y1,y2,xn,yn,cosA,cosA90,d,drls;
   int j,i;
   for(i=0;i<KOL;i++) {
      l=attack_vector_group[i];
	   p=attack_vector_air[l.n_bomb];
	   if (!l.meet)
      {
         x2=l.xmeet;y2=l.ymeet;
         x1=p.x;y1=p.y;
         d=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
         if (d!=0)
         {
            cosA=(y2-y1)/d;
            cosA90=(x2-x1)/d;
            xn=p.v*dt*cosA90;
            yn=p.v*dt*cosA;
            attack_vector_air[l.n_bomb].x+=xn;
            attack_vector_air[l.n_bomb].y+=yn;
            if ((Attack_ABS(x1-x2)<=Attack_ABS(xn))&&
				    (Attack_ABS(y1-y2)<=Attack_ABS(yn)))
            {
					attack_vector_air[l.n_bomb].x=x2;
					attack_vector_air[l.n_bomb].y=y2;
            }
         }
         attack_vector_air[l.n_bomb].fuel-=p.v*dt;

         for(j=0;j<attack_max_sopr;j++)
         {
            if (l.n_istr[j]==-1) continue;
            p=attack_vector_air[l.n_istr[j]];
            x1=p.x;y1=p.y;
            d=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
            if (d!=0)
            {
               cosA=(y2-y1)/d;
               cosA90=(x2-x1)/d;
               xn=p.v*dt*cosA90;
               yn=p.v*dt*cosA;
               attack_vector_air[l.n_istr[j]].x+=xn;
               attack_vector_air[l.n_istr[j]].y+=yn;
               if ((Attack_ABS(x1-x2)<=Attack_ABS(xn))&&
                   (Attack_ABS(y1-y2)<=Attack_ABS(yn)))
               {
	               attack_vector_air[l.n_istr[j]].x=x2;
	               attack_vector_air[l.n_istr[j]].y=y2;
               }
            }
            attack_vector_air[l.n_istr[j]].fuel-=p.v*dt;
         }
      }
      else
      {
			      if (!l.Yespike) {
					x2=objects[tt_RLS].x;
					y2=objects[tt_RLS].y;
					drls=sqrt((x2-p.x)*(x2-p.x)+(y2-p.y)*(y2-p.y));
					};
			      if ((l.Tpike==attack_tpike)&&(drls<=rls_radius)) {
					Attack_pike(attack_vector_group[i],attack_vector_air[l.n_bomb]);
					attack_vector_group[i].Yespike=1;
					l=attack_vector_group[i];p=attack_vector_air[l.n_bomb];
					};
			      if (l.Yespike&&l.Tpike) {
					Attack_do_pike(attack_vector_group[i]);
					l=attack_vector_group[i];p=attack_vector_air[l.n_bomb];
					};
			      x1=p.x;y1=p.y;
			      x2=l.xobj;y2=l.yobj;
			      d=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
			      if (d==0) continue;//printf() or exit();
			      cosA=(y2-y1)/d;
			      cosA90=(x2-x1)/d;
			      xn=p.v*dt*cosA90;
			      yn=p.v*dt*cosA;
			      attack_vector_air[l.n_bomb].x+=xn;
			      attack_vector_air[l.n_bomb].y+=yn;
			      if ((Attack_ABS(x1-x2)<=Attack_ABS(xn))&&
				       (Attack_ABS(y1-y2)<=Attack_ABS(yn))) {
					attack_vector_air[l.n_bomb].x=x2;
					attack_vector_air[l.n_bomb].y=y2;
					xn=x2-x1;yn=y2-y1;
					};
			      attack_vector_air[l.n_bomb].fuel-=p.v*dt;
			      for(j=0;j<attack_max_sopr;j++) {
					if (l.n_istr[j]==-1) continue;
					p=attack_vector_air[l.n_istr[j]];
					attack_vector_air[l.n_istr[j]].x+=xn;
					attack_vector_air[l.n_istr[j]].y+=yn;
					attack_vector_air[l.n_istr[j]].fuel-=p.v*dt;
					};
			      };
	};
};

/* Attack_pike :

  1. Zadanie dlya manevra neobxodimix parametrov: dv,dh,Tpike.

*/

void Attack_pike(attack_group &wi,attack_air &wj)
{
  double hnew=(wj.h-attack_hmin)*Attack_rnd()+attack_hmin;
  wi.dh=(wj.h-hnew)/(attack_tpike/dt);
  double vnew=(attack_vbmax-attack_vbmin)*Attack_rnd()+attack_vbmin;
  wi.dv=(wj.v-vnew)/(attack_tpike/dt);
 };

/* Attack_pike :

  1. Bipolnenie manevra.

*/

void Attack_do_pike(attack_group &wi)
{
   wi.Tpike-=dt;
   if (wi.Tpike<=0) wi.Tpike=0;
   attack_vector_air[wi.n_bomb].h-=wi.dh;
   attack_vector_air[wi.n_bomb].v-=wi.dv;
   for(int j=0;j<attack_max_sopr;j++) {
	if (wi.n_istr[j]==-1) continue;
          attack_vector_air[wi.n_istr[j]].h-=wi.dh;
          attack_vector_air[wi.n_istr[j]].v-=wi.dv;
	  };
 };


